osgShadow::StandardShadowMap::ViewData Struct Reference

`#include <StandardShadowMap>`

Inheritance diagram for osgShadow::StandardShadowMap::ViewData:

## Public Member Functions

virtual void | init (ThisClass *st, osgUtil::CullVisitor *cv)
virtual void | cull ()
virtual void | aimShadowCastingCamera (const osg::BoundingSphere &bounds, const osg::Light *light, const osg::Vec4 &worldLightPos, const osg::Vec3 &worldLightDir, const osg::Vec3 &worldLightUp=osg::Vec3(0, 1, 0))
virtual void | cullShadowReceivingScene ()
virtual void | cullShadowCastingScene ()
virtual void | addShadowReceivingTexGen ()
virtual const osg::Light * | selectLight (osg::Vec4 &viewLightPos, osg::Vec3 &viewLightDir)
virtual void | aimShadowCastingCamera (const osg::Light *light, const osg::Vec4 &worldLightPos, const osg::Vec3 &worldLightDir, const osg::Vec3 &worldLightUp=osg::Vec3(0, 1, 0))
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osgShadow::DebugShadowMap::ViewData
bool | getDebugDraw ()
std::string * | getDebugDump ()
virtual void | init (ThisClass *st, osgUtil::CullVisitor *cv)
virtual void | createDebugHUD (void)
virtual void | cullDebugGeometry ()
virtual void | updateDebugGeometry (const osg::Camera *screenCam, const osg::Camera *shadowCam)
void | setDebugPolytope (const char *name, const ConvexPolyhedron &polytope= *(ConvexPolyhedron *)(NULL), osg::Vec4 colorOutline=osg::Vec4(0, 0, 0, 0), osg::Vec4 colorInside=osg::Vec4(0, 0, 0, 0))
bool | DebugBoundingBox (const osg::BoundingBox &bb, const char *name="")
bool | DebugPolytope (const osg::Polytope &p, const char *name="")
bool | DebugMatrix (const osg::Matrix &m, const char *name="")
void | dump (const std::string &filename)
Public Member Functions inherited from osgShadow::ViewDependentShadowTechnique::ViewData
virtual const char * | className () const
virtual void | init (ViewDependentShadowTechnique *st, osgUtil::CullVisitor *cv)
virtual void | dirty (bool flag)
| ViewData ()
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Public Attributes

osg::ref_ptr< osg::Light > * | _lightPtr
unsigned int * | _baseTextureUnitPtr
unsigned int * | _shadowTextureUnitPtr
osg::ref_ptr< osg::TexGen > | _texgen
osg::ref_ptr< osg::StateSet > | _stateset
Public Attributes inherited from osgShadow::DebugShadowMap::ViewData
osg::ref_ptr< osg::Texture > | _texture
osg::ref_ptr< osg::Camera > | _camera
osg::Matrixd | _viewProjection
osg::observer_ptr< osg::Camera > | _viewCamera
osg::ref_ptr< osg::Shader > | _depthColorFragmentShader
osg::Vec2s | _hudSize
osg::Vec2s | _hudOrigin
osg::Vec2s | _viewportSize
osg::Vec2s | _viewportOrigin
osg::Vec2s | _orthoSize
osg::Vec2s | _orthoOrigin
bool * | _doDebugDrawPtr
std::string * | _debugDumpPtr
PolytopeGeometryMap | _polytopeGeometryMap
osg::ref_ptr< osg::Geode > | _geode [2]
osg::ref_ptr< osg::MatrixTransform > | _transform [2]
std::map< std::string, osg::Matrix > | _matrixMap
std::map< std::string, osg::Polytope > | _polytopeMap
std::map< std::string, osg::BoundingBox > | _boundingBoxMap
osg::ref_ptr< osg::Camera > | _cameraDebugHUD
Public Attributes inherited from osgShadow::ViewDependentShadowTechnique::ViewData
OpenThreads::Mutex | _mutex
bool | _dirty
osg::observer_ptr< osgUtil::CullVisitor > | _cv
osg::observer_ptr< ViewDependentShadowTechnique > | _st

## Additional Inherited Members

Public Types inherited from osgShadow::DebugShadowMap::ViewData
typedef std::map< std::string, PolytopeGeometry > | PolytopeGeometryMap
Static Public Member Functions inherited from osgShadow::DebugShadowMap::ViewData
static osg::Vec3d | computeShadowTexelToPixelError (const osg::Matrix &mvpwView, const osg::Matrix &mvpwShadow, const osg::Vec3d &vWorld, const osg::Vec3d &vDelta=osg::Vec3d(0.01, 0.01, 0.01))
static void | displayShadowTexelToPixelErrors (const osg::Camera *viewCam, const osg::Camera *shadowCam, const ConvexPolyhedron *hull)
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Member Function Documentation

## addShadowReceivingTexGen()

virtual void osgShadow::StandardShadowMap::ViewData::addShadowReceivingTexGen | ( |  | ) |

virtual

## aimShadowCastingCamera() [1/2]

virtual void osgShadow::StandardShadowMap::ViewData::aimShadowCastingCamera | ( | const osg::BoundingSphere & | bounds,
|  | const osg::Light * | light,
|  | const osg::Vec4 & | worldLightPos,
|  | const osg::Vec3 & | worldLightDir,
|  | const osg::Vec3 & | worldLightUp = osg::Vec3(0, 1, 0) )

virtual

Reimplemented in osgShadow::MinimalShadowMap::ViewData.

## aimShadowCastingCamera() [2/2]

virtual void osgShadow::StandardShadowMap::ViewData::aimShadowCastingCamera | ( | const osg::Light * | light,
|  | const osg::Vec4 & | worldLightPos,
|  | const osg::Vec3 & | worldLightDir,
|  | const osg::Vec3 & | worldLightUp = osg::Vec3(0, 1, 0) )

virtual

Reimplemented in osgShadow::MinimalCullBoundsShadowMap::ViewData, and osgShadow::MinimalShadowMap::ViewData.

## cull()

virtual void osgShadow::StandardShadowMap::ViewData::cull | ( |  | ) |

virtual

Method called by ViewDependentShadowTechnique to allow ViewData do the hard work computing shadows for its associated view

Reimplemented from osgShadow::DebugShadowMap::ViewData.

## cullShadowCastingScene()

virtual void osgShadow::StandardShadowMap::ViewData::cullShadowCastingScene | ( |  | ) |

virtual

## cullShadowReceivingScene()

virtual void osgShadow::StandardShadowMap::ViewData::cullShadowReceivingScene | ( |  | ) |

virtual

Reimplemented in osgShadow::MinimalCullBoundsShadowMap::ViewData, osgShadow::MinimalDrawBoundsShadowMap::ViewData, and osgShadow::MinimalShadowMap::ViewData.

## init()

virtual void osgShadow::StandardShadowMap::ViewData::init | ( | ThisClass * | st,
|  | osgUtil::CullVisitor * | cv )

virtual

## releaseGLObjects()

virtual void osgShadow::StandardShadowMap::ViewData::releaseGLObjects | ( | osg::State * | = 0 | ) | const

virtual

If State is non-zero, this function releases any associated OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objects for all graphics contexts.

Reimplemented from osgShadow::DebugShadowMap::ViewData.

Reimplemented in osgShadow::MinimalDrawBoundsShadowMap::ViewData.

## resizeGLObjectBuffers()

virtual void osgShadow::StandardShadowMap::ViewData::resizeGLObjectBuffers | ( | unsigned int | maxSize | ) |

virtual

Reimplemented from osgShadow::DebugShadowMap::ViewData.

Reimplemented in osgShadow::MinimalDrawBoundsShadowMap::ViewData.

## selectLight()

virtual const osg::Light * osgShadow::StandardShadowMap::ViewData::selectLight | ( | osg::Vec4 & | viewLightPos,
|  | osg::Vec3 & | viewLightDir )

virtual

## Member Data Documentation

## _baseTextureUnitPtr

unsigned int* osgShadow::StandardShadowMap::ViewData::_baseTextureUnitPtr

## _lightPtr

osg::ref_ptr< osg::Light >* osgShadow::StandardShadowMap::ViewData::_lightPtr

## _shadowTextureUnitPtr

unsigned int* osgShadow::StandardShadowMap::ViewData::_shadowTextureUnitPtr

## _stateset

osg::ref_ptr<osg::StateSet> osgShadow::StandardShadowMap::ViewData::_stateset

## _texgen

osg::ref_ptr<osg::TexGen> osgShadow::StandardShadowMap::ViewData::_texgen

The documentation for this struct was generated from the following file:

- StandardShadowMap